Index: branches/LearningClassifierSystems/HeuristicLab.Encodings.DecisionList/3.3/HeuristicLab.Encodings.DecisionList-3.3.csproj
===================================================================
--- branches/LearningClassifierSystems/HeuristicLab.Encodings.DecisionList/3.3/HeuristicLab.Encodings.DecisionList-3.3.csproj	(revision 9494)
+++ branches/LearningClassifierSystems/HeuristicLab.Encodings.DecisionList/3.3/HeuristicLab.Encodings.DecisionList-3.3.csproj	(revision 9605)
@@ -93,4 +93,5 @@
     <Compile Include="Action\IntAction.cs" />
     <Compile Include="Analyzer\BestTrainingDecisionListAnalyzer.cs" />
+    <Compile Include="Creators\SmartDecisionListCreator.cs" />
     <Compile Include="Creators\UniformRandomDecisionListCreator.cs" />
     <Compile Include="Crossover\SinglePointCrossover.cs" />
Index: branches/LearningClassifierSystems/HeuristicLab.Encodings.DecisionList/3.3/Interfaces/IDecisionListCreator.cs
===================================================================
--- branches/LearningClassifierSystems/HeuristicLab.Encodings.DecisionList/3.3/Interfaces/IDecisionListCreator.cs	(revision 9494)
+++ branches/LearningClassifierSystems/HeuristicLab.Encodings.DecisionList/3.3/Interfaces/IDecisionListCreator.cs	(revision 9605)
@@ -26,5 +26,5 @@
 
 namespace HeuristicLab.Encodings.DecisionList {
-  public interface IDecisionListCreator : IDecisionListOperator, ISolutionCreator, IStochasticOperator, IGAssistIndividualCreator {
+  public interface IDecisionListCreator : IDecisionListOperator, ISolutionCreator, IStochasticOperator, IGAssistSolutionCreator {
     IValueLookupParameter<IDecisionListClassificationProblemData> ProblemDataParameter { get; }
     ILookupParameter<DecisionList> DecisionListParameter { get; }
Index: branches/LearningClassifierSystems/HeuristicLab.Encodings.DecisionList/3.3/Interfaces/IDecisionListEvaluator.cs
===================================================================
--- branches/LearningClassifierSystems/HeuristicLab.Encodings.DecisionList/3.3/Interfaces/IDecisionListEvaluator.cs	(revision 9494)
+++ branches/LearningClassifierSystems/HeuristicLab.Encodings.DecisionList/3.3/Interfaces/IDecisionListEvaluator.cs	(revision 9605)
@@ -25,5 +25,5 @@
 
 namespace HeuristicLab.Encodings.DecisionList {
-  public interface IDecisionListEvaluator : IStrataSingleObjectiveEvaluator {
+  public interface IDecisionListEvaluator : IGAssistObjectiveEvaluator {
     ILookupParameter<DecisionList> DecisionListParameter { get; }
     IValueLookupParameter<IDecisionListClassificationProblemData> ProblemDataParameter { get; }
Index: branches/LearningClassifierSystems/HeuristicLab.Encodings.DecisionList/3.3/Plugin.cs.frame
===================================================================
--- branches/LearningClassifierSystems/HeuristicLab.Encodings.DecisionList/3.3/Plugin.cs.frame	(revision 9494)
+++ branches/LearningClassifierSystems/HeuristicLab.Encodings.DecisionList/3.3/Plugin.cs.frame	(revision 9605)
@@ -27,6 +27,12 @@
   [PluginDependency("HeuristicLab.Collections", "3.3")]
   [PluginDependency("HeuristicLab.Common", "3.3")]
-  [PluginDependency("HeuristicLab.Common.Resources", "3.3")]
+  [PluginDependency("HeuristicLab.Core", "3.3")]
+  [PluginDependency("HeuristicLab.Data", "3.3")]
+  [PluginDependency("HeuristicLab.Operators", "3.3")]
+  [PluginDependency("HeuristicLab.Optimization", "3.3")]
+  [PluginDependency("HeuristicLab.Optimization.Operators.LCS", "3.3")]
+  [PluginDependency("HeuristicLab.Parameters", "3.3")]
   [PluginDependency("HeuristicLab.Persistence", "3.3")]
+  [PluginDependency("HeuristicLab.Problems.DataAnalysis", "3.4")]
   public class HeuristicLabEncodingsDecisionListPlugin : PluginBase {
   }
Index: branches/LearningClassifierSystems/HeuristicLab.Encodings.DecisionList/3.3/Rule.cs
===================================================================
--- branches/LearningClassifierSystems/HeuristicLab.Encodings.DecisionList/3.3/Rule.cs	(revision 9494)
+++ branches/LearningClassifierSystems/HeuristicLab.Encodings.DecisionList/3.3/Rule.cs	(revision 9605)
@@ -43,4 +43,8 @@
     public IAction Action { get { return action; } }
 
+    public double Length {
+      get { return variables.Values.Sum(x => x.Length); }
+    }
+
     [StorableConstructor]
     protected Rule(bool deserializing) : base(deserializing) { }
@@ -77,9 +81,22 @@
     }
 
-    public void Randomize(IRandom random, double onePercentage, IEnumerable<IDiscretizer> discretizer) {
+    public void Randomize(IRandom random, double oneProbability, IEnumerable<IDiscretizer> discretizers, IEnumerable<IAction> exceptActions = null) {
       foreach (var variable in variables.Values) {
-        variable.Randomize(random, onePercentage, discretizer);
+        variable.Randomize(random, oneProbability, discretizers);
       }
-      action.Randomize(random);
+      if (exceptActions == null) {
+        action.Randomize(random);
+      } else {
+        action.Randomize(random, exceptActions);
+      }
+    }
+
+    public void SetToMatchInput(IGAssistInput input) {
+      foreach (var variable in variables) {
+        if (!input.VariableNames.Contains(variable.Key)) {
+          throw new ArgumentException("input does not contain variable name of rule");
+        }
+        variable.Value.SetToMatch(input.GetVariableValue(variable.Key));
+      }
     }
 
Index: branches/LearningClassifierSystems/HeuristicLab.Encodings.DecisionList/3.3/Variable/DoubleVariable.cs
===================================================================
--- branches/LearningClassifierSystems/HeuristicLab.Encodings.DecisionList/3.3/Variable/DoubleVariable.cs	(revision 9494)
+++ branches/LearningClassifierSystems/HeuristicLab.Encodings.DecisionList/3.3/Variable/DoubleVariable.cs	(revision 9605)
@@ -191,5 +191,14 @@
     public override void Reinitialize(IRandom random, double onePercentage, IEnumerable<IDiscretizer> descretizers) {
       Randomize(random, onePercentage, descretizers);
-      return;
+    }
+
+    public override void SetToMatch(string variableValue) {
+      var value = double.Parse(variableValue);
+      var realCutpoints = GetValuesToCutPoints(discretizer.GetCutPoints(variableName), curIntervals);
+      int pos = 0;
+      while (value >= realCutpoints[pos]) {
+        pos++;
+      }
+      attributes[pos] = true;
     }
   }
Index: branches/LearningClassifierSystems/HeuristicLab.Encodings.DecisionList/3.3/Variable/IVariable.cs
===================================================================
--- branches/LearningClassifierSystems/HeuristicLab.Encodings.DecisionList/3.3/Variable/IVariable.cs	(revision 9494)
+++ branches/LearningClassifierSystems/HeuristicLab.Encodings.DecisionList/3.3/Variable/IVariable.cs	(revision 9605)
@@ -27,4 +27,5 @@
 namespace HeuristicLab.Encodings.DecisionList {
   public interface IVariable : IItem {
+    double Length { get; }
     string VariableName { get; }
     Type VariableType { get; }
@@ -43,4 +44,6 @@
 
     void Split(IRandom Random);
+
+    void SetToMatch(string variableValue);
   }
 }
Index: branches/LearningClassifierSystems/HeuristicLab.Encodings.DecisionList/3.3/Variable/IntVariable.cs
===================================================================
--- branches/LearningClassifierSystems/HeuristicLab.Encodings.DecisionList/3.3/Variable/IntVariable.cs	(revision 9494)
+++ branches/LearningClassifierSystems/HeuristicLab.Encodings.DecisionList/3.3/Variable/IntVariable.cs	(revision 9605)
@@ -68,4 +68,11 @@
       return attributes[possibleFeatures.IndexOf(input)];
     }
+
+    public override void SetToMatch(string variableValue) {
+      var value = int.Parse(variableValue);
+      if (!possibleFeatures.Contains(value)) throw new ArgumentException("variableValue " + variableValue + " is not a possible value of variable " + variableName);
+
+      attributes[possibleFeatures.IndexOf(value)] = true;
+    }
   }
 }
Index: branches/LearningClassifierSystems/HeuristicLab.Encodings.DecisionList/3.3/Variable/StringVariable.cs
===================================================================
--- branches/LearningClassifierSystems/HeuristicLab.Encodings.DecisionList/3.3/Variable/StringVariable.cs	(revision 9494)
+++ branches/LearningClassifierSystems/HeuristicLab.Encodings.DecisionList/3.3/Variable/StringVariable.cs	(revision 9605)
@@ -64,4 +64,11 @@
       return attributes[possibleFeatures.IndexOf(input)];
     }
+
+    public override void SetToMatch(string variableValue) {
+      var valueIndex = possibleFeatures.IndexOf(variableValue);
+      if (valueIndex == -1) throw new ArgumentException("variableValue " + variableValue + " is not a possible value of variable " + variableName);
+
+      attributes[valueIndex] = true;
+    }
   }
 }
Index: branches/LearningClassifierSystems/HeuristicLab.Encodings.DecisionList/3.3/Variable/Variable.cs
===================================================================
--- branches/LearningClassifierSystems/HeuristicLab.Encodings.DecisionList/3.3/Variable/Variable.cs	(revision 9494)
+++ branches/LearningClassifierSystems/HeuristicLab.Encodings.DecisionList/3.3/Variable/Variable.cs	(revision 9605)
@@ -38,4 +38,8 @@
     }
 
+    public double Length {
+      get { return attributes.Count; }
+    }
+
     [Storable]
     protected string variableName;
@@ -72,4 +76,6 @@
     public abstract bool Match(string input);
 
+    public abstract void SetToMatch(string variableValue);
+
     public virtual string ToFullString() { throw new NotImplementedException(); }
 
Index: branches/LearningClassifierSystems/HeuristicLab.Encodings.VariableVector/3.3/Plugin.cs.frame
===================================================================
--- branches/LearningClassifierSystems/HeuristicLab.Encodings.VariableVector/3.3/Plugin.cs.frame	(revision 9494)
+++ branches/LearningClassifierSystems/HeuristicLab.Encodings.VariableVector/3.3/Plugin.cs.frame	(revision 9605)
@@ -25,6 +25,14 @@
   [Plugin("HeuristicLab.Encodings.VariableVector", "3.3.7.$WCREV$")]
   [PluginFile("HeuristicLab.Encodings.VariableVector-3.3.dll", PluginFileType.Assembly)]
-  [PluginDependency("HeuristicLab.Common.Resources", "3.3")]
+  [PluginDependency("HeuristicLab.Collections", "3.3")]
+  [PluginDependency("HeuristicLab.Common", "3.3")]
+  [PluginDependency("HeuristicLab.Core", "3.3")]
   [PluginDependency("HeuristicLab.Data", "3.3")]
+  [PluginDependency("HeuristicLab.Encodings.ConditionActionEncoding", "3.3")]
+  [PluginDependency("HeuristicLab.Operators", "3.3")]
+  [PluginDependency("HeuristicLab.Optimization", "3.3")]
+  [PluginDependency("HeuristicLab.Parameters", "3.3")]
+  [PluginDependency("HeuristicLab.Persistence", "3.3")]
+  [PluginDependency("HeuristicLab.Problems.DataAnalysis", "3.4")]
   public class HeuristicLabEncodingsVariableVectorPlugin : PluginBase {
   }
Index: branches/LearningClassifierSystems/HeuristicLab.Optimization.Operators.LCS/3.3/GAssist/DefaultRule/AutoDefaultRule.cs
===================================================================
--- branches/LearningClassifierSystems/HeuristicLab.Optimization.Operators.LCS/3.3/GAssist/DefaultRule/AutoDefaultRule.cs	(revision 9605)
+++ branches/LearningClassifierSystems/HeuristicLab.Optimization.Operators.LCS/3.3/GAssist/DefaultRule/AutoDefaultRule.cs	(revision 9605)
@@ -0,0 +1,125 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+using HeuristicLab.Parameters;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Optimization.Operators.LCS.DefaultRule {
+  [Item("AutoDefaultRule", "Description missing")]
+  [StorableClass]
+  public class AutoDefaultRule : DefaultRuleOperator, IStochasticOperator {
+
+    #region Parameter Properties
+    public ILookupParameter<IRandom> RandomParameter {
+      get { return (ILookupParameter<IRandom>)Parameters["Random"]; }
+    }
+    public IValueLookupParameter<ItemDictionary<IGAssistNiche, ItemList<DoubleValue>>> AverageAccuraciesParameter {
+      get { return (IValueLookupParameter<ItemDictionary<IGAssistNiche, ItemList<DoubleValue>>>)Parameters["AverageAccuracies"]; }
+    }
+    public ILookupParameter<ItemArray<DoubleValue>> QualityParameter {
+      get { return (ILookupParameter<ItemArray<DoubleValue>>)Parameters["Quality"]; }
+    }
+    public IValueLookupParameter<IntValue> AccuraciesCountParameter {
+      get { return (IValueLookupParameter<IntValue>)Parameters["AccuraciesCount"]; }
+    }
+    public IValueLookupParameter<IGAssistNicheEqualityComparer> NicheComparerParameter {
+      get { return (IValueLookupParameter<IGAssistNicheEqualityComparer>)Parameters["NicheComparer"]; }
+    }
+    public IValueLookupParameter<DoubleValue> NicheStandardDeviationParameter {
+      get { return (IValueLookupParameter<DoubleValue>)Parameters["NicheStandardDeviation"]; }
+    }
+    #endregion
+
+    public ItemDictionary<IGAssistNiche, ItemList<DoubleValue>> AverageAccuracies { get { return AverageAccuraciesParameter.ActualValue; } }
+    public int AccuraciesCount { get { return AccuraciesCountParameter.ActualValue.Value; } }
+
+    [StorableConstructor]
+    protected AutoDefaultRule(bool deserializing) : base(deserializing) { }
+    protected AutoDefaultRule(AutoDefaultRule original, Cloner cloner)
+      : base(original, cloner) {
+    }
+    public AutoDefaultRule()
+      : base() {
+      Parameters.Add(new ValueLookupParameter<ItemDictionary<IGAssistNiche, ItemList<DoubleValue>>>("AverageAccuracies"));
+      Parameters.Add(new ScopeTreeLookupParameter<DoubleValue>("Quality"));
+      Parameters.Add(new LookupParameter<IRandom>("Random"));
+      Parameters.Add(new ValueLookupParameter<IntValue>("AccuraciesCount", new IntValue(15)));
+      Parameters.Add(new ValueLookupParameter<IGAssistNicheEqualityComparer>("NicheComparer"));
+      Parameters.Add(new ValueLookupParameter<DoubleValue>("NicheStandardDeviation", new DoubleValue(0.005)));
+    }
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new AutoDefaultRule(this, cloner);
+    }
+
+    public override IOperation Apply() {
+      if (NichingParameter.ActualValue == null) {
+        IList<IGAssistNiche> niches = GAssistNichesProblemDataParameter.ActualValue.GetPossibleNiches().ToList();
+        NichingParameter.ActualValue = new BoolValue(true);
+        NichesParameter.ActualValue = new IntValue(niches.Count);
+        AverageAccuraciesParameter.ActualValue = new ItemDictionary<IGAssistNiche, ItemList<DoubleValue>>(NicheComparerParameter.ActualValue as IEqualityComparer<IGAssistNiche>);
+        foreach (var niche in GAssistNichesProblemDataParameter.ActualValue.GetPossibleNiches()) {
+          AverageAccuracies.Add(niche, new ItemList<DoubleValue>(AccuraciesCount));
+        }
+      } else {
+        var nicheFitness = new Dictionary<IGAssistNiche, double>(NicheComparerParameter.ActualValue);
+        foreach (var niche in GAssistNichesProblemDataParameter.ActualValue.GetPossibleNiches()) {
+          nicheFitness[niche] = 0.0;
+          while (AverageAccuracies[niche].Count >= AccuraciesCount) {
+            AverageAccuracies[niche].RemoveAt(AverageAccuracies.Count - 1);
+          }
+        }
+
+        var qualityEnumerator = QualityParameter.ActualValue.GetEnumerator();
+        var individualEnumerator = IndividualParameter.ActualValue.GetEnumerator();
+        while (qualityEnumerator.MoveNext() && individualEnumerator.MoveNext()) {
+          if (nicheFitness[individualEnumerator.Current.Niche] < qualityEnumerator.Current.Value) {
+            nicheFitness[individualEnumerator.Current.Niche] = qualityEnumerator.Current.Value;
+          }
+        }
+
+        foreach (var niche in GAssistNichesProblemDataParameter.ActualValue.GetPossibleNiches()) {
+          AverageAccuracies[niche].Insert(0, new DoubleValue(nicheFitness[niche]));
+        }
+
+        var averages = new List<double>(GAssistNichesProblemDataParameter.ActualValue.GetPossibleNiches().Count());
+        if (AverageAccuracies.Values.First().Count >= AccuraciesCount) {
+          foreach (var averageAccuracy in AverageAccuracies.Values) {
+            averages.Add(averageAccuracy.Select(x => x.Value).Average());
+          }
+          double avg = averages.Average();
+          double sum = averages.Sum(d => Math.Pow(d - avg, 2));
+          double std = Math.Sqrt(sum / averages.Count);
+
+          if (std < NicheStandardDeviationParameter.ActualValue.Value) {
+            NichingParameter.ActualValue.Value = false;
+          }
+        }
+      }
+      return base.Apply();
+    }
+  }
+}
Index: branches/LearningClassifierSystems/HeuristicLab.Optimization.Operators.LCS/3.3/GAssist/DefaultRule/DefaultRuleOperator.cs
===================================================================
--- branches/LearningClassifierSystems/HeuristicLab.Optimization.Operators.LCS/3.3/GAssist/DefaultRule/DefaultRuleOperator.cs	(revision 9605)
+++ branches/LearningClassifierSystems/HeuristicLab.Optimization.Operators.LCS/3.3/GAssist/DefaultRule/DefaultRuleOperator.cs	(revision 9605)
@@ -0,0 +1,66 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+using HeuristicLab.Operators;
+using HeuristicLab.Parameters;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Optimization.Operators.LCS {
+  [Item("DefaultRuleOperator", "Description missing")]
+  [StorableClass]
+  public abstract class DefaultRuleOperator : SingleSuccessorOperator, IDefaultRuleOperator {
+
+    #region Parameter Properties
+    public IValueLookupParameter<BoolValue> NichingParameter {
+      get { return (IValueLookupParameter<BoolValue>)Parameters["Niching"]; }
+    }
+    public IValueLookupParameter<IntValue> NichesParameter {
+      get { return (IValueLookupParameter<IntValue>)Parameters["Niches"]; }
+    }
+    public IValueLookupParameter<IGAssistNiche> DefaultClassParameter {
+      get { return (IValueLookupParameter<IGAssistNiche>)Parameters["DefaultClass"]; }
+    }
+    public ILookupParameter<IGAssistProblemData> GAssistNichesProblemDataParameter {
+      get { return (ILookupParameter<IGAssistProblemData>)Parameters["GAssistNichesProblemData"]; }
+    }
+    public ILookupParameter<ItemArray<IGAssistIndividual>> IndividualParameter {
+      get { return (ILookupParameter<ItemArray<IGAssistIndividual>>)Parameters["Individual"]; }
+    }
+    #endregion
+
+    [StorableConstructor]
+    protected DefaultRuleOperator(bool deserializing) : base(deserializing) { }
+    protected DefaultRuleOperator(DefaultRuleOperator original, Cloner cloner)
+      : base(original, cloner) {
+    }
+    public DefaultRuleOperator()
+      : base() {
+      Parameters.Add(new ValueLookupParameter<BoolValue>("Niching"));
+      Parameters.Add(new ValueLookupParameter<IntValue>("Niches"));
+      Parameters.Add(new ValueLookupParameter<IGAssistNiche>("DefaultClass"));
+      Parameters.Add(new LookupParameter<IGAssistProblemData>("GAssistNichesProblemData"));
+      Parameters.Add(new ScopeTreeLookupParameter<IGAssistIndividual>("Individual"));
+    }
+  }
+}
Index: branches/LearningClassifierSystems/HeuristicLab.Optimization.Operators.LCS/3.3/GAssist/DefaultRule/DisabledDefaultRule.cs
===================================================================
--- branches/LearningClassifierSystems/HeuristicLab.Optimization.Operators.LCS/3.3/GAssist/DefaultRule/DisabledDefaultRule.cs	(revision 9605)
+++ branches/LearningClassifierSystems/HeuristicLab.Optimization.Operators.LCS/3.3/GAssist/DefaultRule/DisabledDefaultRule.cs	(revision 9605)
@@ -0,0 +1,52 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Optimization.Operators.LCS {
+  [Item("DisabledDefaultRule", "Description missing")]
+  [StorableClass]
+  public class DisabledDefaultRule : DefaultRuleOperator {
+
+    [StorableConstructor]
+    protected DisabledDefaultRule(bool deserializing) : base(deserializing) { }
+    protected DisabledDefaultRule(DisabledDefaultRule original, Cloner cloner)
+      : base(original, cloner) {
+    }
+    public DisabledDefaultRule()
+      : base() {
+    }
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new DisabledDefaultRule(this, cloner);
+    }
+
+    public override IOperation Apply() {
+      if (NichingParameter.ActualValue == null) {
+        NichingParameter.ActualValue = new BoolValue(false);
+        NichesParameter.ActualValue = new IntValue(1);
+      }
+      return base.Apply();
+    }
+  }
+}
Index: branches/LearningClassifierSystems/HeuristicLab.Optimization.Operators.LCS/3.3/GAssist/DefaultRule/IDefaultRuleOperator.cs
===================================================================
--- branches/LearningClassifierSystems/HeuristicLab.Optimization.Operators.LCS/3.3/GAssist/DefaultRule/IDefaultRuleOperator.cs	(revision 9605)
+++ branches/LearningClassifierSystems/HeuristicLab.Optimization.Operators.LCS/3.3/GAssist/DefaultRule/IDefaultRuleOperator.cs	(revision 9605)
@@ -0,0 +1,33 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+
+namespace HeuristicLab.Optimization.Operators.LCS {
+  public interface IDefaultRuleOperator : IOperator {
+    IValueLookupParameter<BoolValue> NichingParameter { get; }
+    IValueLookupParameter<IntValue> NichesParameter { get; }
+    IValueLookupParameter<IGAssistNiche> DefaultClassParameter { get; }
+    ILookupParameter<IGAssistProblemData> GAssistNichesProblemDataParameter { get; }
+    ILookupParameter<ItemArray<IGAssistIndividual>> IndividualParameter { get; }
+  }
+}
Index: branches/LearningClassifierSystems/HeuristicLab.Optimization.Operators.LCS/3.3/GAssist/DefaultRule/MajorDefaultRule.cs
===================================================================
--- branches/LearningClassifierSystems/HeuristicLab.Optimization.Operators.LCS/3.3/GAssist/DefaultRule/MajorDefaultRule.cs	(revision 9605)
+++ branches/LearningClassifierSystems/HeuristicLab.Optimization.Operators.LCS/3.3/GAssist/DefaultRule/MajorDefaultRule.cs	(revision 9605)
@@ -0,0 +1,76 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System.Collections.Generic;
+using System.Linq;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+using HeuristicLab.Parameters;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Optimization.Operators.LCS.DefaultRule {
+  [Item("MajorDefaultRule", "Description missing")]
+  [StorableClass]
+  public class MajorDefaultRule : DefaultRuleOperator, IStochasticOperator {
+
+    #region Parameter Properties
+    public ILookupParameter<IRandom> RandomParameter {
+      get { return (ILookupParameter<IRandom>)Parameters["Random"]; }
+    }
+    #endregion
+
+    [StorableConstructor]
+    protected MajorDefaultRule(bool deserializing) : base(deserializing) { }
+    protected MajorDefaultRule(MajorDefaultRule original, Cloner cloner)
+      : base(original, cloner) {
+    }
+    public MajorDefaultRule()
+      : base() {
+      Parameters.Add(new LookupParameter<IRandom>("Random"));
+    }
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new MajorDefaultRule(this, cloner);
+    }
+
+    public override IOperation Apply() {
+      if (NichingParameter.ActualValue == null) {
+        NichingParameter.ActualValue = new BoolValue(false);
+        NichesParameter.ActualValue = new IntValue(1);
+        var problemData = GAssistNichesProblemDataParameter.ActualValue;
+        var trainingIndices = problemData.TrainingIndices;
+        var actions = problemData.FetchAction(trainingIndices);
+
+        Dictionary<IGAssistNiche, int> classCount = new Dictionary<IGAssistNiche, int>(actions.First().Comparer);
+        foreach (var niche in GAssistNichesProblemDataParameter.ActualValue.GetPossibleNiches()) {
+          classCount[niche] = 0;
+        }
+        foreach (var action in actions) {
+          classCount[action] += 1;
+        }
+        var maxAction = classCount.MaxItems(x => x.Value).ToList();
+        var index = RandomParameter.ActualValue.Next(0, maxAction.Count);
+        DefaultClassParameter.ActualValue = maxAction[index].Key;
+      }
+      return base.Apply();
+    }
+  }
+}
